//+------------------------------------------------------------------+
//|                                                 MoneyManager.mqh |
//|                                                       Oleg Peyko |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Oleg Peyko"
#property link      "http://www.mql5.com"

enum MoneyManager_ManageType_enum
  {
   FixLot=0,// fix lot
   ByStartingBalance=1,//  by starting balance
   PercentByBalance=2,// Percent by current balance
  } enum_ManageType;

class MoneyManager
  {

private:
   double            MoneyManager_startingBalance;
   double            MoneyManager_startingLot;
   double            MoneyManager_minimalLot;
   double            MoneyManager_maximalLot;
   double            MoneyManager_percentage;
   int               MoneyManager_ManageType;
public:

                     MoneyManager()
     {
      MoneyManager_startingBalance = AccountInfoDouble(ACCOUNT_BALANCE);
      MoneyManager_startingLot = SymbolInfoDouble(Symbol(),SYMBOL_VOLUME_MIN);
      MoneyManager_minimalLot = SymbolInfoDouble(Symbol(),SYMBOL_VOLUME_MIN);
      MoneyManager_maximalLot = SymbolInfoDouble(Symbol(),SYMBOL_VOLUME_MAX);
      MoneyManager_percentage = 0;
     }


   void              SetStartParams(double min, double max , double percent, double startLot, double startBalance ,MoneyManager_ManageType_enum type)
     {
      if((min>0) && (min > MoneyManager_minimalLot))
         MoneyManager_minimalLot = min;
      if((max>0) && (max < MoneyManager_maximalLot))
         MoneyManager_maximalLot = max;
      if (percent>0)   MoneyManager_percentage = percent;
      if (startLot>0) MoneyManager_startingLot = startLot;
      if (startBalance>0) MoneyManager_startingBalance = startBalance;
      MoneyManager_ManageType = type;
     }

   double            GetLot(double CurrentBalance)
     {
      double result = 0;
      if(MoneyManager_ManageType == 1)
        {
         result = NormalizeDouble(CurrentBalance/MoneyManager_startingBalance*MoneyManager_startingLot,2);
        }
      else
         if(MoneyManager_ManageType == 2)
           {
            result = NormalizeDouble(CurrentBalance*MoneyManager_percentage/100,2);
           }
         else
            result = MoneyManager_startingLot;

      if(result<MoneyManager_minimalLot)
         result=MoneyManager_minimalLot;
      if(result > MoneyManager_maximalLot)
         result = MoneyManager_maximalLot;
      return result;
     }
  };
//+------------------------------------------------------------------+
